// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * Contient toutes les &eacute;num&eacute;ration du jeu
 */
package enumeration;

/**
 * Contient les diff&eacute;rents mouvements du joueur
 * 
 * @author J&eacute;r&eacute;my Chevrier
 * @version 0.1.1 : 2011-01-18, 6:10pm<br>
 *          0.1.2 : 2011-01-19, 8:34pm<br>
 */
public enum Moving {
	/**
	 * Bas
	 */
	DOWN (0), /**
	 * Gauche
	 */
	LEFT (1), /**
	 * Droite
	 */
	RIGHT (2), /**
	 * Haut
	 */
	UP (3);

	/**
	 * Direction d'un élément (Bas, Gauche, Droite, Haut)
	 */
	private int direction;

	/**
	 * Constructeur
	 * 
	 * @param direction
	 *            La direction
	 */
	private Moving (int direction) {
		this.direction = direction;
	}

	/**
	 * Récupère la direction
	 * 
	 * @return La direction
	 */
	public int getDirection () {
		return direction;
	}
}
