// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////

/**
 * 
 */
package gameStates;

import loader.menus.MenuLoader;

import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.state.transition.FadeInTransition;
import org.newdawn.slick.state.transition.FadeOutTransition;

/**
 * @author jeremy
 * 
 */
public class IntroductionMovie extends BasicGameState {

	/**
	 * Le state
	 */
	private int state;
	private int image;
	private int yCoor;
	private int deltaCpt, deltaG;

	public IntroductionMovie (int state) {
		this.setState (state);
	}

	/*
	 * (non-Javadoc)
	 * @see
	 * org.newdawn.slick.state.GameState#init(org.newdawn.slick.GameContainer,
	 * org.newdawn.slick.state.StateBasedGame)
	 */
	@Override
	public void init (GameContainer gc, StateBasedGame sbg) throws SlickException {
		image = 0;
		yCoor = 0;
		deltaCpt = 0;
		deltaG = 0;
	}

	/*
	 * (non-Javadoc)
	 * @see
	 * org.newdawn.slick.state.GameState#render(org.newdawn.slick.GameContainer,
	 * org.newdawn.slick.state.StateBasedGame, org.newdawn.slick.Graphics)
	 */
	@Override
	public void render (GameContainer gc, StateBasedGame sbg, Graphics g) throws SlickException {
		switch (image) {
			case 0:
				MenuLoader.getHashMapImage ().get ("97").draw (0, yCoor);
				break;
			case 1:
				MenuLoader.getHashMapImage ().get ("98").draw (0, yCoor);
				break;
			case 2:
				MenuLoader.getHashMapImage ().get ("99").draw (0, yCoor);
				break;
		}
		
	}

	/*
	 * (non-Javadoc)
	 * @see
	 * org.newdawn.slick.state.GameState#update(org.newdawn.slick.GameContainer,
	 * org.newdawn.slick.state.StateBasedGame, int)
	 */
	@Override
	public void update (GameContainer gc, StateBasedGame sbg, int delta) throws SlickException {
		deltaCpt += delta;
		deltaG += delta;
		if (deltaCpt > 10 && yCoor - 1 > -571) yCoor -= 1;
		if (deltaG > 25000) {
			if (image + 1 < 3) {
				image++;
				yCoor = 0;
				deltaG = 0;
				deltaCpt = 0;
			} else {
				sbg.enterState (1, new FadeOutTransition (Color.black, 2000), new FadeInTransition (Color.black, 2000));
			}
		}
	}

	/*
	 * (non-Javadoc)
	 * @see org.newdawn.slick.state.BasicGameState#getID()
	 */
	@Override
	public int getID () {
		return 5;
	}

	/**
	 * @param state
	 *            the state to set
	 */
	public void setState (int state) {
		this.state = state;
	}

	/**
	 * @return the state
	 */
	public int getState () {
		return state;
	}

	/**
	 * @param image
	 *            the image to set
	 */
	public void setImage (int image) {
		this.image = image;
	}

	/**
	 * @return the image
	 */
	public int getImage () {
		return image;
	}

	/**
	 * @param deltaCpt
	 *            the deltaCpt to set
	 */
	public void setDeltaCpt (int deltaCpt) {
		this.deltaCpt = deltaCpt;
	}

	/**
	 * @return the deltaCpt
	 */
	public int getDeltaCpt () {
		return deltaCpt;
	}

	/**
	 * @param deltaG
	 *            the deltaG to set
	 */
	public void setDeltaG (int deltaG) {
		this.deltaG = deltaG;
	}

	/**
	 * @return the deltaG
	 */
	public int getDeltaG () {
		return deltaG;
	}
}
