// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package loader;

import java.io.File;
import java.util.HashMap;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;

/**
 * @author Jérémy Chevrier
 * 
 */
public class AnimatedLoader {
	///////////////
	// Attributs //
	///////////////
	/**
	 * La feuille de sprite
	 */
	private static HashMap<String, SpriteSheet> hashMapSpriteSheet = new HashMap<String, SpriteSheet> ();
	/**
	 * La liste des chemins de toutes les fichiers à charger
	 */
	private static File[] list;

	////////////////////////
	// Méthodes statiques //
	////////////////////////
	/**
	 * @param spriteSheetPath
	 * @param tileWidth
	 * @param tileHeight
	 * @return
	 */
	private static SpriteSheet spriteSheetLoader (String spriteSheetPath, int tileWidth, int tileHeight) {
		SpriteSheet spriteSheet = null;
		try {
			spriteSheet = new SpriteSheet (spriteSheetPath, tileWidth, tileHeight);
		}
		catch (SlickException e) {
			System.out.println ("No spritesheet found !");
			e.printStackTrace ();
		}
		return spriteSheet;
	}
	
	/**
	 * Charge toutes les images du joueur.
	 */
	public static void spritesLoader (String folderPath) {
		File directory = new File (folderPath); // On fixe le dossier contenant les maps
		if (directory.isDirectory ()) setList (directory.listFiles ()); // On charge la liste des fichiers contenu dans ce dossier
		for (File file : getList ()) {
			if (!file.isDirectory ()) { // Si c'est un fichier, alors on le charge
				String[] key = file.getPath ().split ("_")[1].split (".png"); // On récupère la clé
				getHashMapSpriteSheet ().put (key[0], spriteSheetLoader (file.getPath (), 32, 32)); // On charge la map et on la met dans une hashTable
			}
		}
	}

	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @param hashMapSpriteSheet
	 *            the hashMapSpriteSheet to set
	 */
	public static void setHashMapSpriteSheet (HashMap<String, SpriteSheet> hashMapSpriteSheet) {
		AnimatedLoader.hashMapSpriteSheet = hashMapSpriteSheet;
	}

	/**
	 * @return the hashMapSpriteSheet
	 */
	public static HashMap<String, SpriteSheet> getHashMapSpriteSheet () {
		return hashMapSpriteSheet;
	}

	/**
	 * @param list the list to set
	 */
	public static void setList (File[] list) {
		AnimatedLoader.list = list;
	}

	/**
	 * @return the list
	 */
	public static File[] getList () {
		return list;
	}
}
