// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package loader;

import java.io.File;
import java.util.HashMap;

import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;

/**
 * @author Jérémy Chevrier
 * @version 0.1.1 : 2011-01-25, 2:22pm<br>
 * 			0.1.2 : 2011-01-27, 4:50pm
 */
public abstract class ImagesLoader {
	///////////////
	// Attributs //
	///////////////
	/**
	 * Liste de toutes les images d'une catégorie
	 */
	private static HashMap<String, Image> hashMapImage = new HashMap<String, Image> ();
	/**
	 * La liste des chemins de toutes les fichiers à charger
	 */
	private static File[] list;

	////////////////////////
	// Méthodes statiques //
	////////////////////////
	/**
	 * Charge une image à partir d'un fichier
	 * 
	 * @param filePath
	 *            Le chemin du fichier
	 * @return une image
	 */
	public static Image imageLoader (String filePath) {
		Image image = null;
		try {
			image = new Image (filePath);
		}
		catch (SlickException e) {
			System.out.println ("Image not found");
			e.printStackTrace ();
		}
		return image;
	}

	/**
	 * Charge toutes les images des monstres du jeu
	 */
	public static void imagesLoader (String folderPath) {}

	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @param hashMapImage
	 *            the hashMapImage to set
	 */
	public static void setHashMapImage (HashMap<String, Image> hashMapImage) {
		ImagesLoader.hashMapImage = hashMapImage;
	}

	/**
	 * @return the hashMapImage
	 */
	public static HashMap<String, Image> getHashMapImage () {
		return hashMapImage;
	}

	/**
	 * @param list
	 *            the list to set
	 */
	public static void setList (File[] list) {
		ImagesLoader.list = list;
	}

	/**
	 * @return the list
	 */
	public static File[] getList () {
		return list;
	}
}
