// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////

/**
 * 
 */
package loader.characters;

import java.io.File;
import java.util.HashMap;

import loader.SKillsPropLoader;
import model.characters.Monster;
import modules.MonsterReader;

/**
 * @author jeremy
 *
 */
public class MonstersPropLoader {
///////////////
	// Attributs //
	///////////////
	/**
	 * Liste de toutes les images d'une catégorie
	 */
	private static HashMap<String, Monster> hashMapMonsters = new HashMap<String, Monster> ();
	/**
	 * La liste des chemins de toutes les fichiers à charger
	 */
	private static File[] list;

	////////////////////////
	// Méthodes statiques //
	////////////////////////
	/**
	 * Charge toutes les images des monstres du jeu
	 */
	public static void monsterLoader (String folderPath) {
		MonsterReader mr = new MonsterReader ();
		File directory = new File ("data/ressources/characters/monsters/properties/"); // On fixe le dossier contenant les maps
		if (directory.isDirectory ()) setList (directory.listFiles ()); // On charge la liste des fichiers contenu dans ce dossier
		for (File file : getList ()) {
			if (!file.isDirectory ()) { // Si c'est un fichier, alors on le charge
				String[] key = file.getPath ().split ("_")[1].split (".xdat"); // On récupère la clé
				getHashMapMonsters ().put (key[0], (Monster) mr.getGameObject (file.getPath (), SKillsPropLoader.getHashMapSkills ())); // On charge la map et on la met dans une hashTable
			}
		}
	}

	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @param list the list to set
	 */
	public static void setList (File[] list) {
		MonstersPropLoader.list = list;
	}

	/**
	 * @return the list
	 */
	public static File[] getList () {
		return list;
	}

	/**
	 * @param hashMapMonsters the hashMapMonsters to set
	 */
	public static void setHashMapMonsters (HashMap<String, Monster> hashMapMonsters) {
		MonstersPropLoader.hashMapMonsters = hashMapMonsters;
	}

	/**
	 * @return the hashMapMonsters
	 */
	public static HashMap<String, Monster> getHashMapMonsters () {
		return hashMapMonsters;
	}
}
