// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package loader.characters;

import java.io.File;
import java.util.HashMap;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;

/**
 * @author bece
 *
 */
public class NpcsDynamicLoader {
	/**
	 * La feuille de sprites bas
	 */
	private static HashMap<String, SpriteSheet> spriteSheetList = new HashMap<String, SpriteSheet> ();
	/**
	 * La feuille de sprites haut
	 */
	private static HashMap<String, SpriteSheet> spriteSheetListTop = new HashMap<String, SpriteSheet> ();
	/**
	 * La list
	 */
	private static File[] list;

	////////////////////////
	// Méthodes statiques //
	////////////////////////
	/**
	 * @param spriteSheetPath
	 * @param tileWidth
	 * @param tileHeight
	 * @return
	 */
	private static SpriteSheet spriteSheetLoader (String spriteSheetPath, int tileWidth, int tileHeight) {
		SpriteSheet spriteSheet = null;
		try {
			spriteSheet = new SpriteSheet (spriteSheetPath, tileWidth, tileHeight);
		}
		catch (SlickException e) {
			System.out.println ("No spritesheet found !");
			e.printStackTrace ();
		}
		return spriteSheet;
	}

	/**
	 * Charge tous les sprites.
	 */
	public static void spriteLoader (String folderPath) {
		File directory = new File (folderPath); // On fixe le dossier contenant les maps
		if (directory.isDirectory ()) setList (directory.listFiles ()); // On charge la liste des fichiers contenu dans ce dossier
		for (File file : getList ()) {
			if (!file.isDirectory ()) { // Si c'est un fichier, alors on le charge
				String[] key = file.getPath ().split ("_")[1].split (".png"); // On récupère la clé
				if (file.getParentFile ().getName ().equalsIgnoreCase ("top")) getSpriteSheetListTop ().put (key[0], spriteSheetLoader (file.getPath (), 32, 32));
				else if (file.getParentFile ().getName ().equalsIgnoreCase ("bottom")) getSpriteSheetList ().put (key[0], spriteSheetLoader (file.getPath (), 32, 32));;
			}
			else {
				if (!file.isHidden ()) {
					spriteLoader (file.getPath ());
				}
			}
		}
	}

	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @param list the list to set
	 */
	public static void setList (File[] list) {
		NpcsDynamicLoader.list = list;
	}

	/**
	 * @return the list
	 */
	public static File[] getList () {
		return list;
	}

	/**
	 * @param spriteSheetList the spriteSheetList to set
	 */
	public static void setSpriteSheetList (HashMap<String, SpriteSheet> spriteSheetList) {
		NpcsDynamicLoader.spriteSheetList = spriteSheetList;
	}

	/**
	 * @return the spriteSheetList
	 */
	public static HashMap<String, SpriteSheet> getSpriteSheetList () {
		return spriteSheetList;
	}

	/**
	 * @param spriteSheetListTop the spriteSheetListTop to set
	 */
	public static void setSpriteSheetListTop (HashMap<String, SpriteSheet> spriteSheetListTop) {
		NpcsDynamicLoader.spriteSheetListTop = spriteSheetListTop;
	}

	/**
	 * @return the spriteSheetListTop
	 */
	public static HashMap<String, SpriteSheet> getSpriteSheetListTop () {
		return spriteSheetListTop;
	}
}
