// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * Ce package va regrouper toutes les classes de chargement des ressources de
 * tout le jeu.
 */
package loader.characters;

import java.io.File;
import java.util.HashMap;

import loader.ImagesLoader;

import org.newdawn.slick.Image;

/**
 * <p>
 * <code>NpcsStaticLoader</code> qui va charger tous les PNJ du jeu
 * </p>
 * 
 * @author Jérémy Chevrier
 * @version 0.1.1 : 2011-01-20, 11:41pm
 */
public class NpcsStaticLoader extends ImagesLoader {
	/**
	 * La liste des images de la tête
	 */
	private static HashMap<String, Image> hashMapImageTop = new HashMap<String, Image> ();

	/**
	 * Charge toutes les images des monstres du jeu
	 */
	public static void imagesLoader (String folderPath) {
		File directory = new File (folderPath); // On fixe le dossier contenant les maps
		if (directory.isDirectory ()) setList (directory.listFiles ()); // On charge la liste des fichiers contenu dans ce dossier
		for (File file : getList ()) {
			if (!file.isDirectory ()) { // Si c'est un fichier, alors on le charge
				String[] key = file.getPath ().split ("_")[1].split (".png"); // On récupère la clé
				if (file.getParentFile ().getName ().equalsIgnoreCase ("top")) getHashMapImageTop ().put (key[0], imageLoader (file.getPath ()));
				else if (file.getParentFile ().getName ().equalsIgnoreCase ("bottom")) getHashMapImage ().put (key[0], imageLoader (file.getPath ()));;
			}
			else {
				if (!file.isHidden ()) {
					imagesLoader (file.getPath ());
				}
			}
		}
	}

	/**
	 * @param hashMapImageTop the hashMapImageTop to set
	 */
	public static void setHashMapImageTop (HashMap<String, Image> hashMapImageTop) {
		NpcsStaticLoader.hashMapImageTop = hashMapImageTop;
	}

	/**
	 * @return the hashMapImageTop
	 */
	public static HashMap<String, Image> getHashMapImageTop () {
		return hashMapImageTop;
	}
}
