// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package loader.items;

import java.io.File;

import loader.ImagesLoader;

/**
 * <code>ItemsLoader</code> charge les images de toutes les quêtes du jeu.
 * 
 * @author Jérémy Chevrier
 * @version 0.1.1 : 2011-01-25, 2:50pm
 */
public class ItemsLoader extends ImagesLoader {
	/**
	 * Charge toutes les images des monstres du jeu
	 */
	public static void imagesLoader (String folderPath) {
		File directory = new File ("data/ressources/items/questsItems/images/"); // On fixe le dossier contenant les maps
		if (directory.isDirectory ()) setList (directory.listFiles ()); // On charge la liste des fichiers contenu dans ce dossier
		for (File file : getList ()) {
			if (!file.isDirectory ()) { // Si c'est un fichier, alors on le charge
				String[] key = file.getPath ().split ("_")[1].split (".png"); // On récupère la clé
				getHashMapImage ().put (key[0], imageLoader (file.getPath ())); // On charge la map et on la met dans une hashTable
			}
		}
	}
}
