// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////

package loader.menus;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;

public class DiversLoader {

	private static SpriteSheet fightAnimation;
	
	public DiversLoader () {
		try {
			DiversLoader.setFightAnimation (new SpriteSheet ("data/ressources/battle/skills/images/animationAttaque_00.png", 150, 150));
		}
		catch (SlickException e) {
			e.printStackTrace();
		}
	}
	
	private static SpriteSheet spriteSheetLoader (String spriteSheetPath, int tileWidth, int tileHeight) {
		SpriteSheet spriteSheet = null;
		try {
			spriteSheet = new SpriteSheet (spriteSheetPath, tileWidth, tileHeight);
		}
		catch (SlickException e) {
			System.out.println ("No spritesheet found !");
			e.printStackTrace ();
		}
		return spriteSheet;
	}

	/**
	 * @param fightAnimation the fightAnimation to set
	 */
	public static void setFightAnimation (SpriteSheet fightAnimation) {
		DiversLoader.fightAnimation = fightAnimation;
	}

	/**
	 * @return the fightAnimation
	 */
	public static SpriteSheet getFightAnimation () {
		return fightAnimation;
	}
}
