/**
 * 
 */
package loader.menus;

import java.io.File;
import java.util.HashMap;

import loader.ImagesLoader;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;

/**
 * @author Jérémy Chevrier
 * @version 0.1.1 : 2011-01-29, 9:11pm
 */
public class MenuLoader extends ImagesLoader {
	private static HashMap<String, SpriteSheet> hashMapSprite = new HashMap<String, SpriteSheet> ();

	/**
	 * Charge toutes les images des monstres du jeu
	 */
	public static void imagesLoader (String folderPath) {
		File directory = new File (folderPath); // On fixe le dossier contenant les maps
		if (directory.isDirectory ()) setList (directory.listFiles ()); // On charge la liste des fichiers contenu dans ce dossier
		for (File file : getList ()) {
			if (!file.isDirectory ()) { // Si c'est un fichier, alors on le charge
				String[] key = file.getPath ().split ("_")[1].split (".png"); // On récupère la clé
				if (!file.getParentFile ().getName ().equalsIgnoreCase ("sprite")) getHashMapImage ().put (key[0], imageLoader (file.getPath ())); // On charge la map et on la met dans une hashTable
				else if (file.getParentFile ().getName ().equalsIgnoreCase ("sprite")) getHashMapSprite ().put (key[0], spriteSheetLoader (file.getPath (), 12, 12));
			}
			else {
				if (!file.isHidden ()) {
					imagesLoader (file.getPath ());
				}
			}
		}
	}

	private static SpriteSheet spriteSheetLoader (String spriteSheetPath, int tileWidth, int tileHeight) {
		SpriteSheet spriteSheet = null;
		try {
			spriteSheet = new SpriteSheet (spriteSheetPath, tileWidth, tileHeight);
		}
		catch (SlickException e) {
			System.out.println ("No spritesheet found !");
			e.printStackTrace ();
		}
		return spriteSheet;
	}

	/**
	 * @return the hashMapSprite
	 */
	public static HashMap<String, SpriteSheet> getHashMapSprite () {
		return hashMapSprite;
	}

	/**
	 * @param hashMapSprite the hashMapSprite to set
	 */
	public static void setHashMapSprite (HashMap<String, SpriteSheet> hashMapSprite) {
		MenuLoader.hashMapSprite = hashMapSprite;
	}
}
