// ////////////////////////////////////////////////////////////////////////
// Copyright  2011 Jrmy Chevrier, Hugo Buffet, Jrmy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details. //
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////

package model;

import org.newdawn.slick.Image;

/**
 * Classe abstraite dcrivant les bases d'un objet du jeu.
 * 
 * @author Hugo Buffet
 * @version 0.1.1 : 2011-01-20, 10:23am</br>
 * @version 0.1.2 : 2011-01-26, 11:12pm</br>
 * 
 */
public abstract class GameObject {

	////////////////
	// Attributes //
	////////////////

	/**
	 * Correspond  l'identifiant de l'objet du jeu
	 */
	private String key;

	/**
	 * Correspond  l'avatar de l'objet du jeu
	 */
	private Image avatar;

	/**
	 * Correspond  la description de l'objet du jeu
	 */
	private String description;
	
	/**
	 * Correspond au nom de l'objet du jeu
	 */
	private String name;

	/////////////////
	// Constructor //
	/////////////////
	/**
	 * @param key
	 *            l'identifiant du GameObject
	 * @param avatar
	 *            l'image du GameObject
	 * @param description
	 *            la description du GameObject
	 * @param description
	 *            le nom du GameObject        
	 *            
	 */
	public GameObject (String key, Image avatar, String description, String name) {
		super ();
		this.key = key;
		this.avatar = avatar;
		this.description = description;
		this.name = name;
	}
	
	///////////////
	// Accessors //
	///////////////

	/**
	 * @return the key
	 */
	public String getKey () {
		return key;
	}

	/**
	 * @param key the key to set
	 */
	public void setKey (String key) {
		this.key = key;
	}

	/**
	 * @return the avatar
	 */
	public Image getAvatar () {
		return avatar;
	}

	/**
	 * @param avatar the avatar to set
	 */
	public void setAvatar (Image avatar) {
		this.avatar = avatar;
	}

	/**
	 * @return the description
	 */
	public String getDescription () {
		return description;
	}

	/**
	 * @param description the description to set
	 */
	public void setDescription (String description) {
		this.description = description;
	}

	/**
	 * @return the name
	 */
	public String getName () {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName (String name) {
		this.name = name;
	}

}