// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////

/**
 * 
 */
package model;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

/**
 * @author jeremy Chevrier
 * 
 */
public class SaveLoad {

	/**
	 * Sauvegarde les variables du jeu
	 * 
	 * @param gameVar
	 * @param keyMap
	 * @param xHero
	 * @param yHero
	 */
	public static void saveGame (int[] gameVar, String keyMap, int xHero, int yHero, String name) {
		FileWriter writer = null;
		String pathFile = "data/saves/";
		String nameFile = "";
		try {
			if (name.split (";")[1].equalsIgnoreCase ("Nouveau")) {
				File file1 = new File (pathFile + name.split (";")[0] + "_01.save");
				if (file1.exists ()) {
					File file2 = new File (pathFile + name.split (";")[0] + "_02.save");
					if (file2.exists ()) {
						nameFile = name.split (";")[0] + "_03.save";
					}
					else nameFile = name.split (";")[0] + "_02.save";
				}
				else nameFile = name.split (";")[0] + "_01.save";
			}
			else {
				nameFile = name.split (";")[1];
			}
			writer = new FileWriter (pathFile + nameFile, false);
			for (int i = 0; i < gameVar.length; i++) {
				if (i == 2) {
					String texte = i + ";" + xHero + "\n";
					writer.write (texte, 0, texte.length ());
				}
				else if (i == 3) {
					String texte = i + ";" + yHero + "\n";
					writer.write (texte, 0, texte.length ());
				}
				else if (i == 4) {
					String texte = i + ";" + keyMap + "\n";
					writer.write (texte, 0, texte.length ());
				}
				else if (gameVar[i] != 0) {
					String texte = i + ";" + gameVar[i] + "\n";
					writer.write (texte, 0, texte.length ());
				}
			}
		}
		catch (IOException e) {
			e.printStackTrace ();
		}
		finally {
			if (writer != null) {
				try {
					writer.close ();
				}
				catch (IOException e) {
					e.printStackTrace ();
				}
			}
		}
	}

	/**
	 * Charge les variables du jeu
	 * 
	 * @return
	 */
	public static ArrayList<String[]> loadGame (String name) {
		String filePath = "data/saves/" + name;
		ArrayList<String[]> listVar = new ArrayList<String[]> ();

		Scanner scanner = null;
		try {
			scanner = new Scanner (new File (filePath));
			// On boucle sur chaque champ detecté
			while (scanner.hasNextLine ()) {
				String line = scanner.nextLine ();
				String[] lineSplit = line.split (";");
				listVar.add (lineSplit);
			}
		}
		catch (FileNotFoundException e) {
			e.printStackTrace ();
		}
		finally {
			scanner.close ();
		}
		return listVar;
	}
}
