// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package model.events;

import model.GameObject;

import org.newdawn.slick.Image;

/**
 * <p>
 * <code>Event</code représente un objet évènement.
 * </p>
 * 
 * @author Jérémy Chevrier
 * @version 0.1.1 : 2011-01-21, 10:57am</br>
 * @version 0.1.2 : 2011-01-26, 11:20pm</br>
 * @version 0.1.3 : 2011-01-27, 5:50pm</br>
 * 
 */
public class Event extends GameObject {
	///////////////
	// Attributs //
	///////////////
	/**
	 * Etat de l'évènement
	 */
	private boolean actived;
	/**
	 * Abscisse de l'évènement
	 */
	private int xEvent;
	/**
	 * Ordonnée de l'évènement
	 */
	private int yEvent;
	/**
	 * Evènement graphique (ou non)
	 */
	private boolean graphic;
	/**
	 * Identifiant local de l'�v�nement (au niveau de la map)
	 */
	private int localkey;
	/**
	 * Type de l'�v�nement
	 */
	private String eventType;

	//////////////////
	// Constructeur //
	//////////////////
	public Event (String key, Image avatar, String description, int xEvent, int yEvent, String name, int localKey, String eventType) {
		super (key, avatar, description, name);
		if (description.equals ("")) this.setGraphic (false);
		else this.setGraphic (true);
		this.xEvent = xEvent;
		this.yEvent = yEvent;
		this.localkey = localKey;
		this.eventType = eventType;
		this.setActived (true);
	}

	//////////////
	// Méthodes //
	//////////////

	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @return the actived
	 */
	public boolean isActived () {
		return actived;
	}

	/**
	 * @param actived
	 *            the actived to set
	 */
	public void setActived (boolean actived) {
		this.actived = actived;
	}

	/**
	 * @return the xEvent
	 */
	public int getxEvent () {
		return xEvent;
	}

	/**
	 * @param xEvent
	 *            the xEvent to set
	 */
	public void setxEvent (int xEvent) {
		this.xEvent = xEvent;
	}

	/**
	 * @return the yEvent
	 */
	public int getyEvent () {
		return yEvent;
	}

	/**
	 * @param yEvent
	 *            the yEvent to set
	 */
	public void setyEvent (int yEvent) {
		this.yEvent = yEvent;
	}

	/**
	 * @return the graphic
	 */
	public boolean isGraphic () {
		return graphic;
	}

	/**
	 * @param graphic
	 *            the graphic to set
	 */
	public void setGraphic (boolean graphic) {
		this.graphic = graphic;
	}

	/**
	 * @return the localkey
	 */
	public int getLocalkey () {
		return localkey;
	}

	/**
	 * @param localkey the localkey to set
	 */
	public void setLocalkey (int localkey) {
		this.localkey = localkey;
	}

	/**
	 * @return the enventType
	 */
	public String getEventType () {
		return eventType;
	}

	/**
	 * @param enventType the enventType to set
	 */
	public void setEventType (String eventType) {
		this.eventType = eventType;
	}
	
}
