// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package model.events;

import java.util.ArrayList;

import model.various.Message;

import org.newdawn.slick.Image;

/**
 * @author Jérémy Chevrier
 *
 */
public class NpcEvent extends Event {

	///////////////
	// Attributs //
	///////////////
	/**
	 * La liste des messages
	 */
	private ArrayList<Message> listMessage;
	/**
	 * La valeur du perso dans le tableau
	 */
	private int valueArrayIndex;
	/**
	 * La clé de l'event que l'on souhaite modifier
	 */
	private String keyValueEvent;

	//////////////////
	// Constructeur //
	//////////////////
	public NpcEvent (String key, Image avatar, String description, int xEvent, int yEvent, String name, int localKey, String eventType, int valueArrayIndex, String keyValueEvent, ArrayList<Message> messageList) {
		super (key, avatar, description, xEvent, yEvent, name, localKey, eventType);
		this.setListMessage (messageList);
		this.setxEvent (xEvent);
		this.setyEvent (yEvent);
		this.setValueArrayIndex (valueArrayIndex);
		this.setKeyValueEvent (keyValueEvent);
	}

	//////////////
	// Méthodes //
	//////////////

	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @param listMessage the listMessage to set
	 */
	public void setListMessage (ArrayList<Message> listMessage) {
		this.listMessage = listMessage;
	}

	/**
	 * @return the listMessage
	 */
	public ArrayList<Message> getListMessage () {
		return listMessage;
	}

	/**
	 * @param valueArrayIndex the valueArrayIndex to set
	 */
	public void setValueArrayIndex (int valueArrayIndex) {
		this.valueArrayIndex = valueArrayIndex;
	}

	/**
	 * @return the valueArrayIndex
	 */
	public int getValueArrayIndex () {
		return valueArrayIndex;
	}

	/**
	 * @param keyValueEvent the keyValueEvent to set
	 */
	public void setKeyValueEvent (String keyValueEvent) {
		this.keyValueEvent = keyValueEvent;
	}

	/**
	 * @return the keyValueEvent
	 */
	public String getKeyValueEvent () {
		return keyValueEvent;
	}
}
