// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package model.events;

import org.newdawn.slick.Image;

import enumeration.Moving;

/**
 * @author Jérémy Chevrier
 *
 */
public class PortalEvent extends Event{

	///////////////
	// Attributs //
	///////////////
	/**
	 * location x sur la map
	 */
	private int heroXLocation;
	/**
	 * Location y sur la map
	 */
	private int heroYLocation;
	/**
	 * La direction vers laquelle est la sortie
	 */
	private Moving move;
	/**
	 * La clé de la map vers laquelle l'évènement redirige
	 */
	private String keyMap;

	//////////////////
	// Constructeur //
	//////////////////
	public PortalEvent (String key, Image avatar, String description, int xEvent, int yEvent, String name, int localKey, String eventType, String keyMap, int heroXLocation, int heroYLocation, Moving move) {
		super (key, avatar, description, xEvent, yEvent, name, localKey, eventType);
		this.setHeroXLocation (heroXLocation);
		this.setHeroYLocation (heroYLocation);
		this.setKeyMap (keyMap);
		this.setMove (move);
	}

	//////////////
	// Méthodes //
	//////////////

	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @param keyMap the keyMap to set
	 */
	public void setKeyMap (String keyMap) {
		this.keyMap = keyMap;
	}

	/**
	 * @return the keyMap
	 */
	public String getKeyMap () {
		return keyMap;
	}

	/**
	 * @param heroXLocation the heroXLocation to set
	 */
	public void setHeroXLocation (int heroXLocation) {
		this.heroXLocation = heroXLocation;
	}

	/**
	 * @return the heroXLocation
	 */
	public int getHeroXLocation () {
		return heroXLocation;
	}

	/**
	 * @param heroYLocation the heroYLocation to set
	 */
	public void setHeroYLocation (int heroYLocation) {
		this.heroYLocation = heroYLocation;
	}

	/**
	 * @return the heroYLocation
	 */
	public int getHeroYLocation () {
		return heroYLocation;
	}

	/**
	 * @param move the move to set
	 */
	public void setMove (Moving move) {
		this.move = move;
	}

	/**
	 * @return the move
	 */
	public Moving getMove () {
		return move;
	}
}
