// ////////////////////////////////////////////////////////////////////////
// Copyright  2011 Jrmy Chevrier, Hugo Buffet, Jrmy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details. //
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////

package model.items;

import org.newdawn.slick.Image;

/**
 * Classe dcrivant les caractristiques d'une gemme. Elle hrite de Item.
 * 
 * @author Hugo Buffet
 * @version 0.1.1 : 2011-01-20, 10:47am</br>
 * @version 0.1.2 : 2011-01-20, 11:20pm</br>
 * 
 */
public class Gem extends Item {

	////////////////
	// Attributes //
	////////////////
	/**
	 * Correspond au type de la gemme
	 */
	private String gemType;

	/**
	 * Corresponde  l'identifiant de l'esprit contenu dans la gemme
	 */
	private String idSpirit;

	/////////////////
	// Constructor //
	/////////////////
	/**
	 * @param key
	 *            Identifiant de la gemme
	 * @param avatar
	 *            Image de la gemme
	 * @param description
	 *            Description de la gemme
	 * @param price
	 *            Prix de la gemme
	 * @param typeItem
	 * 
	 */
	public Gem (String key, Image avatar, String description, int price, String typeItem, String gemType, String idSpirit, String name) {
		super (key, avatar, description, price, typeItem, name);

		this.gemType = gemType;
		this.idSpirit = idSpirit;
	}

	// /////////////
	// Accessors //
	// /////////////

	/**
	 * @return the gemType
	 */
	public String getGemType () {
		return gemType;
	}

	/**
	 * @param gemType
	 *            the gemType to set
	 */
	public void setGemType (String gemType) {
		this.gemType = gemType;
	}

	/**
	 * @return the idSpirit
	 */
	public String getIdSpirit () {
		return idSpirit;
	}

	/**
	 * @param idSpirit
	 *            the idSpirit to set
	 */
	public void setIdSpirit (String idSpirit) {
		this.idSpirit = idSpirit;
	}

}
