// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package model.maps;

import java.util.Random;

import org.newdawn.slick.Animation;

import loader.AnimatedLoader;

/**
 * @author Jérémy Chevrier
 * 
 */
public class AnimationMap {
	///////////////
	// Attributs //
	///////////////
	/**
	 * Le X
	 */
	private int xCoor;
	/**
	 * le Y
	 */
	private int yCoor;
	/**
	 * La clé de l'animation
	 */
	private String key;
	/**
	 * Le mode (random ou continues)
	 */
	private String mode;
	/**
	 * L'animation
	 */
	private Animation anim;
	/**
	 * Compteur 
	 */
	private int deltaInc;

	//////////////////
	// Constructeur //
	//////////////////
	public AnimationMap (String key, int xCoor, int yCoor, String mode) {
		this.setKey (key);
		this.setxCoor (xCoor);
		this.setyCoor (yCoor);
		this.setMode (mode);
		this.createAnim ();
		if (this.getMode ().equalsIgnoreCase ("random")) this.aleaInc ();
	}

	//////////////
	// Méthodes //
	//////////////
	/**
	 * Création de l'animation
	 */
	public void createAnim () {
		anim = new Animation (AnimatedLoader.getHashMapSpriteSheet ().get (this.getKey ()), 0, 0, 7, 0, true, 200, true);
		anim.start ();
	}

	/**
	 * Dessin de l'animation
	 */
	public void drawAnimation () {
		if (this.getMode ().equalsIgnoreCase ("random")) {
		if (this.getDeltaInc () < 0) {
			if (this.getDeltaInc () > -1600) {
				anim.draw (this.getxCoor (), this.getyCoor ());
			} else {
				this.aleaInc ();
			}
		}
		} else if (this.getMode ().equalsIgnoreCase ("continue")) {
			anim.draw (this.getxCoor (), this.getyCoor ());
		}
	}
	
	private void aleaInc () {
		Random r = new Random ();
		this.setDeltaInc ((r.nextInt (4) + 1) * 1000);
	}

	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @param key
	 *            the key to set
	 */
	public void setKey (String key) {
		this.key = key;
	}

	/**
	 * @return the key
	 */
	public String getKey () {
		return key;
	}

	/**
	 * @param yCoor
	 *            the yCoor to set
	 */
	public void setyCoor (int yCoor) {
		this.yCoor = yCoor;
	}

	/**
	 * @return the yCoor
	 */
	public int getyCoor () {
		return yCoor;
	}

	/**
	 * @param xCoor
	 *            the xCoor to set
	 */
	public void setxCoor (int xCoor) {
		this.xCoor = xCoor;
	}

	/**
	 * @return the xCoor
	 */
	public int getxCoor () {
		return xCoor;
	}

	/**
	 * @param anim
	 *            the anim to set
	 */
	public void setAnim (Animation anim) {
		this.anim = anim;
	}

	/**
	 * @return the anim
	 */
	public Animation getAnim () {
		return anim;
	}

	/**
	 * @param deltaInc the deltaInc to set
	 */
	public void setDeltaInc (int deltaInc) {
		this.deltaInc = deltaInc;
	}

	/**
	 * @return the deltaInc
	 */
	public int getDeltaInc () {
		return deltaInc;
	}

	/**
	 * @param mode the mode to set
	 */
	public void setMode (String mode) {
		this.mode = mode;
	}

	/**
	 * @return the mode
	 */
	public String getMode () {
		return mode;
	}
}
