// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package model.maps;

import loader.characters.NpcsDynamicLoader;

import org.newdawn.slick.Animation;

/**
 * @author Jérémy Chevrier
 * 
 */
public class AnimationNPCMap {
	///////////////
	// Attributs //
	///////////////
	/**
	 * Le X
	 */
	private int xCoor;
	/**
	 * le Y
	 */
	private int yCoor;
	/**
	 * La clé de l'animation
	 */
	private String key;
	/**
	 * 
	 */
	private Animation animBottom;
	/**
	 * L'animation
	 */
	private Animation animTop;

	//////////////////
	// Constructeur //
	//////////////////
	public AnimationNPCMap (String key, int xCoor, int yCoor) {
		this.setKey (key);
		this.setxCoor (xCoor);
		this.setyCoor (yCoor);
		this.createAnim ();
	}

	//////////////
	// Méthodes //
	//////////////
	/**
	 * Création de l'animation
	 */
	public void createAnim () {
		if (NpcsDynamicLoader.getSpriteSheetListTop ().get (this.getKey ()) != null) {
			animTop = new Animation (NpcsDynamicLoader.getSpriteSheetListTop ().get (this.getKey ()), 0, 0, 7, 0, true, 200, true);
			animTop.start ();
		}
		animBottom = new Animation (NpcsDynamicLoader.getSpriteSheetList ().get (this.getKey ()), 0, 0, 7, 0, true, 200, true);
		animBottom.start ();
	}
	
	/**
	 * Dessine le haut du PNJ
	 */
	public void drawNPCAnimTop () {
		if (NpcsDynamicLoader.getSpriteSheetListTop ().get (this.getKey ()) != null) 
			animTop.draw (this.xCoor, this.yCoor - NpcsDynamicLoader.getSpriteSheetListTop ().get (this.getKey ()).getHeight ());
	}

	/**
	 * Dessine le haut du PNJ
	 */
	public void drawNPCAnimBottom () {
		animBottom.draw (this.getxCoor (), this.getyCoor ());
	}
	
	
	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @param xCoor
	 *            the xCoor to set
	 */
	public void setxCoor (int xCoor) {
		this.xCoor = xCoor;
	}

	/**
	 * @return the xCoor
	 */
	public int getxCoor () {
		return xCoor;
	}

	/**
	 * @param yCoor
	 *            the yCoor to set
	 */
	public void setyCoor (int yCoor) {
		this.yCoor = yCoor;
	}

	/**
	 * @return the yCoor
	 */
	public int getyCoor () {
		return yCoor;
	}

	/**
	 * @param key
	 *            the key to set
	 */
	public void setKey (String key) {
		this.key = key;
	}

	/**
	 * @return the key
	 */
	public String getKey () {
		return key;
	}

	/**
	 * @param animTop
	 *            the animTop to set
	 */
	public void setAnim (Animation anim) {
		this.animTop = anim;
	}

	/**
	 * @return the animTop
	 */
	public Animation getAnim () {
		return animTop;
	}

	/**
	 * @param animBottom
	 *            the animBottom to set
	 */
	public void setAnimBottom (Animation animBottom) {
		this.animBottom = animBottom;
	}

	/**
	 * @return the animBottom
	 */
	public Animation getAnimBottom () {
		return animBottom;
	}
}
