// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package model.menu;

import loader.events.EventXMLLoader;

import org.newdawn.slick.Image;

import controller.Controller;

/**
 * @author Jérémy Chevrier
 * @version 0.1.1 : 11:19am
 */
public class Menu {
	///////////////
	// Attributs //
	///////////////
	/**
	 * Le fond
	 */
	private Image background;
	/**
	 * La description
	 */
	private String description;
	/**
	 * Le nom
	 */
	private String name;
	/**
	 * Le type
	 */
	private String type;
	/**
	 * Le tableau des variables
	 */
	private int[] gameVar;
	/**
	 * Le controleur
	 */
	private Controller controller;

	//////////////////
	// Constructeur //
	//////////////////
	/**
	 * Constructeur du menu
	 * 
	 * @param key
	 *            Clé de l'évènement
	 */
	public Menu (String key, int[] gameVar, Controller controller) {
		this.setDescription (EventXMLLoader.getHashMapEvent ().get (key).getDescription ());
		this.setName (EventXMLLoader.getHashMapEvent ().get (key).getName ());
		this.setType (EventXMLLoader.getHashMapEvent ().get (key).getEventType ());
		this.setGameVar (gameVar);
		this.setController (controller);
	}
	
	public Menu (int[] gameVar, Controller controller) {
		this.setGameVar (gameVar);
		this.setController (controller);
	}

	//////////////
	// Méthodes //
	//////////////
	/**
	 * Dessine le menu
	 */
	public void drawMenu () {}

	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @param background
	 *            the background to set
	 */
	public void setBackground (Image background) {
		this.background = background;
	}

	/**
	 * @return the background
	 */
	public Image getBackground () {
		return background;
	}

	/**
	 * @param description
	 *            the description to set
	 */
	public void setDescription (String description) {
		this.description = description;
	}

	/**
	 * @return the description
	 */
	public String getDescription () {
		return description;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName (String name) {
		this.name = name;
	}

	/**
	 * @return the name
	 */
	public String getName () {
		return name;
	}

	/**
	 * @param type
	 *            the type to set
	 */
	public void setType (String type) {
		this.type = type;
	}

	/**
	 * @return the type
	 */
	public String getType () {
		return type;
	}

	/**
	 * @param gameVar the gameVar to set
	 */
	public void setGameVar (int[] gameVar) {
		this.gameVar = gameVar;
	}

	/**
	 * @return the gameVar
	 */
	public int[] getGameVar () {
		return gameVar;
	}

	/**
	 * @param controller the controller to set
	 */
	public void setController (Controller controller) {
		this.controller = controller;
	}

	/**
	 * @return the controller
	 */
	public Controller getController () {
		return controller;
	}
}
