// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////

/**
 * 
 */
package model.menu;

import java.io.File;

import loader.FontLoader;
import loader.menus.AvatarLoader;
import loader.menus.MenuLoader;
import model.various.TxtFileFilter;
import controller.Controller;

/**
 * @author jeremy
 * 
 */
public class SaveMenu extends Menu {

	/**
	 * 
	 */
	private String messageSave;
	/**
	 * 
	 */
	private String messageSaving;
	/**
	 * 
	 */
	private String messageYes;
	/**
	 * 
	 */
	private String messageNo;
	/**
	 * 
	 */
	private String messageLifePoint;
	/**
	 * 
	 */
	private boolean save;
	/**
	 * 
	 */
	private boolean saving;
	/**
	 * 
	 */
	private boolean saveFile;
	/**
	 * 
	 */
	private boolean lifePoint;
	/**
	 * 
	 */
	private String[] fileSave;
	/**
	 * Le curseur pour les slots de sauvegarde
	 */
	private int cursor;

	public SaveMenu (String key, int[] gameVar, Controller controller) {
		super (key, gameVar, controller);
		this.setMessageLifePoint ("Tous vos points de vie ont été restaurés !");
		this.setMessageSave ("Voulez-vous sauvegarder la partie ?");
		this.setMessageNo (" - Non");
		this.setMessageYes (" - Oui");
		this.setLifePoint (true);
		this.setSave (true);
		this.setSaving (false);
		this.setMessageSaving ("La partie a été sauvegardée !");
		File directory = new File ("data/saves/");
		File[] listFile = directory.listFiles (new TxtFileFilter ());
		if (listFile.length > 2) fileSave = new String[3];
		else {
			fileSave = new String[listFile.length + 1];
			fileSave[listFile.length] = "Nouveau";
		}
		for (int i = 0; i < fileSave.length; i++)
			if (i < listFile.length) fileSave[i] = listFile[i].getName ();
		this.setCursor (0);
	}

	public void drawMenu () {
		MenuLoader.getHashMapImage ().get ("00").draw (63, 370); // On affiche les fonds
		MenuLoader.getHashMapImage ().get ("01").draw (63, 416);
		AvatarLoader.getHashMapImage ().get (this.getName ()).draw (67, 374); // On dessine l'avatar
		FontLoader.getFontShadow ().drawString (113, 375, this.getName ()); // On dessine le nom
		FontLoader.getFont ().drawString (112, 374, this.getName ());
		if (this.isLifePoint ()) {
			FontLoader.getFontShadow ().drawString (82, 437, this.getMessageLifePoint ());
			FontLoader.getFont ().drawString (81, 436, this.getMessageLifePoint ());
		}
		else {
			if (!this.isSaving ()) {
				FontLoader.getFontShadow ().drawString (82, 437, this.getMessageSave ());
				FontLoader.getFont ().drawString (81, 436, this.getMessageSave ());
				FontLoader.getFontShadow ().drawString (82, 467, this.getMessageYes ());
				FontLoader.getFont ().drawString (81, 466, this.getMessageYes ());
				FontLoader.getFontShadow ().drawString (82, 497, this.getMessageNo ());
				FontLoader.getFont ().drawString (81, 496, this.getMessageNo ());
				if (!this.isSaveFile ()) {
					if (!this.isSave ()) MenuLoader.getHashMapImage ().get ("12").draw (80, 517);
					else MenuLoader.getHashMapImage ().get ("12").draw (80, 487);
				}
				else {
					if (!this.isSave ()) MenuLoader.getHashMapImage ().get ("12").draw (80, 517);
					else MenuLoader.getHashMapImage ().get ("12").draw (80, 487);
					for (int i = 0; i < fileSave.length; i++) {
						FontLoader.getFontShadow ().drawString (482, 437 + (i * 30), fileSave[i]);
						FontLoader.getFont ().drawString (481, 436 + (i * 30), fileSave[i]);
					}
					MenuLoader.getHashMapImage ().get ("12").draw (480, 457 + (cursor * 30));
				}
			}
			else {
				FontLoader.getFontShadow ().drawString (82, 437, this.getMessageSaving ());
				FontLoader.getFont ().drawString (81, 436, this.getMessageSaving ());
			}
		}
	}

	public void cursorUp () {
		if (this.getCursor () > 0) this.setCursor (this.getCursor () - 1);
	}

	public void cursorDown () {
		if (this.getCursor () < this.getFileSave ().length && this.getCursor () != 2) this.setCursor (this.getCursor () + 1);
	}

	/**
	 * @param messageSave
	 *            the messageSave to set
	 */
	public void setMessageSave (String messageSave) {
		this.messageSave = messageSave;
	}

	/**
	 * @return the messageSave
	 */
	public String getMessageSave () {
		return messageSave;
	}

	/**
	 * @param messageYes
	 *            the messageYes to set
	 */
	public void setMessageYes (String messageYes) {
		this.messageYes = messageYes;
	}

	/**
	 * @return the messageYes
	 */
	public String getMessageYes () {
		return messageYes;
	}

	/**
	 * @param messageNo
	 *            the messageNo to set
	 */
	public void setMessageNo (String messageNo) {
		this.messageNo = messageNo;
	}

	/**
	 * @return the messageNo
	 */
	public String getMessageNo () {
		return messageNo;
	}

	/**
	 * @param save
	 *            the save to set
	 */
	public void setSave (boolean save) {
		this.save = save;
	}

	/**
	 * @return the save
	 */
	public boolean isSave () {
		return save;
	}

	/**
	 * @param saving
	 *            the saving to set
	 */
	public void setSaving (boolean saving) {
		this.saving = saving;
	}

	/**
	 * @return the saving
	 */
	public boolean isSaving () {
		return saving;
	}

	/**
	 * @param messageSaving
	 *            the messageSaving to set
	 */
	public void setMessageSaving (String messageSaving) {
		this.messageSaving = messageSaving;
	}

	/**
	 * @return the messageSaving
	 */
	public String getMessageSaving () {
		return messageSaving;
	}

	/**
	 * @return the saveFile
	 */
	public boolean isSaveFile () {
		return saveFile;
	}

	/**
	 * @param saveFile
	 *            the saveFile to set
	 */
	public void setSaveFile (boolean saveFile) {
		this.saveFile = saveFile;
	}

	/**
	 * @return the fileSave
	 */
	public String[] getFileSave () {
		return fileSave;
	}

	/**
	 * @param fileSave
	 *            the fileSave to set
	 */
	public void setFileSave (String[] fileSave) {
		this.fileSave = fileSave;
	}

	/**
	 * @return the cursor
	 */
	public int getCursor () {
		return cursor;
	}

	/**
	 * @param cursor
	 *            the cursor to set
	 */
	public void setCursor (int cursor) {
		this.cursor = cursor;
	}

	/**
	 * @param lifePoint
	 *            the lifePoint to set
	 */
	public void setLifePoint (boolean lifePoint) {
		this.lifePoint = lifePoint;
	}

	/**
	 * @return the lifePoint
	 */
	public boolean isLifePoint () {
		return lifePoint;
	}

	/**
	 * @param messageLifePoint
	 *            the messageLifePoint to set
	 */
	public void setMessageLifePoint (String messageLifePoint) {
		this.messageLifePoint = messageLifePoint;
	}

	/**
	 * @return the messageLifePoint
	 */
	public String getMessageLifePoint () {
		return messageLifePoint;
	}
}
