// ////////////////////////////////////////////////////////////////////////
// Copyright © 2011 Jérémy Chevrier, Hugo Buffet, Jérémy Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////
/**
 * 
 */
package model.various;

/**
 * @author Jérémy Chevrier
 * 
 */
public class Message {
	///////////////
	// Attributs //
	///////////////
	/**
	 * Le message en lui-même
	 */
	private String message;
	/**
	 * L'index pour la variable de jeu
	 */
	private int index;
	/**
	 * La valeur pour la variable de jeu
	 */
	private int value;
	/**
	 * L'index de la variable de jeu, quand ça change
	 */
	private int indexEdit;
	/**
	 * la valeur pour la variable de jeu, quand ça change
	 */
	private String valueEdit;
	/**
	 * Le type de la valeur (si il y a un a, c'est un ajout, sinon, juste une
	 * affectation)
	 */
	private String valueEditType;
	/**
	 * La valeur réelle à ajouter
	 */
	private int valueEditInt;

	//////////////////
	// Constructeur //
	//////////////////
	/**
	 * Constructeur de l'objet Message
	 * 
	 * @param message
	 *            Le message
	 * @param printable
	 *            Affichable ou non
	 */
	public Message (String message, int index, int value, int indexEdit, String valueEdit) {
		super ();
		this.setMessage (message);
		this.setIndex (index);
		this.setValue (value);
		this.setIndexEdit (indexEdit);
		this.setValueEdit (valueEdit);
	}

	//////////////
	// Méthodes //
	//////////////

	////////////////
	// Accesseurs //
	////////////////
	/**
	 * @param message
	 *            the message to set
	 */
	public void setMessage (String message) {
		this.message = message;
	}

	/**
	 * @return the message
	 */
	public String getMessage () {
		return message;
	}

	/**
	 * @param index
	 *            the index to set
	 */
	public void setIndex (int index) {
		this.index = index;
	}

	/**
	 * @return the index
	 */
	public int getIndex () {
		return index;
	}

	/**
	 * @param value
	 *            the value to set
	 */
	public void setValue (int value) {
		this.value = value;
	}

	/**
	 * @return the value
	 */
	public int getValue () {
		return value;
	}

	/**
	 * @param indexEdit
	 *            the indexEdit to set
	 */
	public void setIndexEdit (int indexEdit) {
		this.indexEdit = indexEdit;
	}

	/**
	 * @return the indexEdit
	 */
	public int getIndexEdit () {
		return indexEdit;
	}

	/**
	 * @param valueEdit
	 *            the valueEdit to set
	 */
	public void setValueEdit (String valueEdit) {
		this.valueEdit = valueEdit;
		if (!valueEdit.equalsIgnoreCase ("")) {
			if (valueEdit.charAt (0) == 'a') {
				this.setValeuEditType ("Add");
				if (valueEdit.charAt (1) == '-') this.setValueEditInt (Integer.parseInt (valueEdit.split ("-")[1]));
				else this.setValueEditInt (Integer.parseInt (valueEdit.split ("a")[1]));
				System.out.println (this.getValueEditInt ());
			}
			else {
				this.setValeuEditType ("Equal");
				if (valueEdit.charAt (0) == '-') this.setValueEditInt (Integer.parseInt (valueEdit.split ("-")[1]));
				else this.setValueEditInt (Integer.parseInt (valueEdit));
				System.out.println (this.getValueEditInt ());
			}
		}
	}

	/**
	 * @return the valueEdit
	 */
	public String getValueEdit () {
		return valueEdit;
	}

	/**
	 * @param valeuEditType
	 *            the valeuEditType to set
	 */
	public void setValeuEditType (String valeuEditType) {
		this.valueEditType = valeuEditType;
	}

	/**
	 * @return the valeuEditType
	 */
	public String getValeuEditType () {
		return valueEditType;
	}

	/**
	 * @param valueEditInt
	 *            the valueEditInt to set
	 */
	public void setValueEditInt (int valueEditInt) {
		this.valueEditInt = valueEditInt;
	}

	/**
	 * @return the valueEditInt
	 */
	public int getValueEditInt () {
		return valueEditInt;
	}
}
