// ////////////////////////////////////////////////////////////////////////
// Copyright ï¿½ 2011 Jï¿½rï¿½my Chevrier, Hugo Buffet, Jï¿½rï¿½my Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details. //
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////

/**
 * 
 */
package modules;

import java.util.ArrayList;
import java.util.List;

import model.events.NpcEvent;
import model.various.Message;

import org.jdom.Document;
import org.jdom.Element;
import org.newdawn.slick.Image;

/**
 * Cette classe correspond au lecteur de NpcEvent.
 * 
 * @author Hugo Buffet
 * @version 0.1.0 : 2011-02-01, 07:40pm</br>
 * 
 */
public class NpcReader extends Reader {

	/*
	 * (non-Javadoc)
	 * @see modules.Reader#getGameObject(java.lang.String)
	 */
	@SuppressWarnings("unchecked")
	public model.GameObject getGameObject (String urlFile) {

		// Dï¿½claration et initialisation des diffï¿½rentes variables
		String key = null;
		Image avatar = null;
		String description = null;
		String name = null;
		int x = 0;
		int y = 0;
		int localKey = 0;
		String eventType;
		ArrayList<Message> listMessages = new ArrayList<Message> ();

		// Chargement du document xml pour traitement
		Document doc = xmlReader (urlFile);

		if (doc != null) {
			// Rï¿½cupï¿½ration de l'ï¿½lï¿½ment racine
			Element root = doc.getRootElement ();

			// Attribution des diffï¿½rentes variables
			key = root.getAttributeValue ("key");
			eventType = root.getAttributeValue ("eventType");
			int valueArrayIndex = (root.getAttribute ("valueArrayIndex") != null ? Integer.parseInt (root.getAttributeValue ("valueArrayIndex")) : 0 );
			description = ((Element) root).getChildText ("description", ((Element) root).getNamespace ());
			name = ((Element) root).getChildText ("name", ((Element) root).getNamespace ());

			List<Element> messBlock = (List) ((Element) root).getChildren ("messages", ((Element) root).getNamespace ());

			int index = 0;
			int value = 0;
			String content = "";
			String keyValueEvent = "";
			keyValueEvent = (root.getAttribute ("keyValueEvent") != null ? root.getAttributeValue ("keyValueEvent") : "" );

			for (Element ms : messBlock) {
				List<Element> messages = (List) ((Element) ms).getChildren ("message", ((Element) root).getNamespace ());

				for (Element message : messages) {
					index = Integer.parseInt (message.getAttributeValue ("index"));
					value = Integer.parseInt (message.getAttributeValue ("value"));
					content = message.getText ();
					if (message.getAttribute ("indexEdit") != null) {
						int indexEdit = Integer.parseInt (message.getAttributeValue ("indexEdit"));
						String valueEdit = message.getAttributeValue ("valueEdit");
						System.out.println (keyValueEvent);
						listMessages.add (new Message (content, index, value, indexEdit, valueEdit));
					} else {
						listMessages.add (new Message (content, index, value, 0, ""));
					}
				}
			}

			// Chargement de l'avatar
			avatar = imageLoader (key);

			// Instanciation du NpcEvent
			System.out.println (keyValueEvent);
			NpcEvent npc = new NpcEvent (key, avatar, description, x, y, name, localKey, eventType, valueArrayIndex, keyValueEvent, listMessages);

			// Retourne le monstre ainsi instanciï¿½
			return npc;
		}

		return null;
	}

	/*
	 * (non-Javadoc)
	 * @see modules.Reader#imageLoader(java.lang.String)
	 */
	@Override
	public Image imageLoader (String keyEvent) {
		// TODO Auto-generated method stub
		return loader.characters.NpcsStaticLoader.getHashMapImage ().get (keyEvent);
	}

}
