// ////////////////////////////////////////////////////////////////////////
// Copyright � 2011 J�r�my Chevrier, Hugo Buffet, J�r�my Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details. //
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////

package tools.graphics;

import javax.swing.JFrame;
import javax.swing.JPanel;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.FontFormatException;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JSeparator;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import javax.swing.JTextField;

import model.Skill;
import modules.SkillReader;

import tools.writers.SkillWriter;

@SuppressWarnings("serial")
public class SkillMaker extends JFrame implements ActionListener, KeyListener {

	private JPanel container = new JPanel ();
	private JMenu menuFile = null;
	private JMenuBar menu;
	private JMenuItem menuFileNew, menuFileOpen, menuFileSave, menuFileQuit;
	private JTextField textFieldKey, textFieldName, textFieldType;
	private JTextArea textFieldDesc;
	private JSpinner spinnerPointCost, spinnerdefBonus, spinnerattBonus,
			spinnerhpBonus, spinnerAuraBonus, spinnerPowerBonus, spinnerAttMalus, spinnerDefMalus,
			spinnerDamages, spinnerHitSuccess;
	private SpinnerNumberModel pointCost = new SpinnerNumberModel (0, 0, 200, 1);
	private SpinnerNumberModel defBonus = new SpinnerNumberModel (0, 0, 200, 1);
	private SpinnerNumberModel attBonus = new SpinnerNumberModel (0, 0, 200, 1);
	private SpinnerNumberModel hpBonus = new SpinnerNumberModel (0, 0, 200, 1);
	private SpinnerNumberModel auraBonus = new SpinnerNumberModel (0, 0, 200, 1);
	private SpinnerNumberModel powerBonus = new SpinnerNumberModel (0, 0, 200, 1);
	private SpinnerNumberModel attMalus = new SpinnerNumberModel (0, 0, 200, 1);
	private SpinnerNumberModel defMalus = new SpinnerNumberModel (0, 0, 200, 1);
	private SpinnerNumberModel damages = new SpinnerNumberModel (0, 0, 1000, 1);
	private SpinnerNumberModel hitSuccess = new SpinnerNumberModel (0, 0, 100, 1);
	private JButton buttonSave;
	private String title = "SkillMaker v1.0";
	private String file = "";
	private String editFile = "";
	private boolean newFile = true;
	private boolean edit = false;

	private Skill skill = null;
	private SkillWriter skillWriter = new SkillWriter ();
	private SkillReader skillReader = new SkillReader ();

	public SkillMaker () {
		super ();
		this.setSize (new Dimension (1024, 768));
		this.setTitle (title);
		this.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
		container.setLayout (new BoxLayout (container, BoxLayout.PAGE_AXIS));
		container.setBorder (BorderFactory.createTitledBorder ("Skill"));
		this.setContentPane (container);

		// On ajoute le menu (et ses différents sous-menus)
		this.ajouterMenuBar ();
		// On ajoute les panneaux
		this.initComponents ();

		this.nouveau ();

		this.setNimbusLook ();
		this.pack ();
		this.setVisible (true);
	}

	private void initComponents () {
		// Initialisation
		// Partie Key
		JPanel panelLabelKey = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelKey = new JLabel ("Key :");
		panelLabelKey.add (labelKey);

		JPanel panelTextFieldKey = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		textFieldKey = new JTextField (20);
		textFieldKey.addKeyListener (this);
		panelTextFieldKey.add (textFieldKey);

		JPanel panelKey = new JPanel (new BorderLayout ());
		panelKey.add (panelLabelKey, BorderLayout.WEST);
		panelKey.add (panelTextFieldKey, BorderLayout.CENTER);

		// Partie Name
		JPanel panelLabelName = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelName = new JLabel ("Name :");
		panelLabelName.add (labelName);

		JPanel panelTextFieldName = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		textFieldName = new JTextField (20);
		textFieldName.addKeyListener (this);
		panelTextFieldName.add (textFieldName);

		JPanel panelName = new JPanel (new BorderLayout ());
		panelName.add (panelLabelName, BorderLayout.WEST);
		panelName.add (panelTextFieldName, BorderLayout.CENTER);

		// Partie Type
		JPanel panelLabelType = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelType = new JLabel ("Type :");
		panelLabelType.add (labelType);

		JPanel panelTextFieldType = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		textFieldType = new JTextField (20);
		textFieldType.addKeyListener (this);
		panelTextFieldType.add (textFieldType);

		JPanel panelType = new JPanel (new BorderLayout ());
		panelType.add (panelLabelType, BorderLayout.WEST);
		panelType.add (panelTextFieldType, BorderLayout.CENTER);

		// Partie Description
		JPanel panelLabelDesc = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelDesc = new JLabel ("Description :");
		panelLabelDesc.add (labelDesc);

		JPanel panelTextFieldDesc = new JPanel (new FlowLayout (FlowLayout.LEFT));
		textFieldDesc = new JTextArea ();
		textFieldDesc.setLineWrap (true);
		textFieldDesc.setWrapStyleWord (true);
		textFieldDesc.addKeyListener (this);
		textFieldDesc.setPreferredSize (new Dimension (660, 120));
		Font font = null;
		try {
			font = new Font (Font.createFont (Font.TRUETYPE_FONT, new FileInputStream (new File ("data/ressources/fonts/AMERSN__.ttf"))).getFamily (), Font.PLAIN, 20);
		}
		catch (FontFormatException e) {
			e.printStackTrace ();
		}
		catch (IOException e) {
			e.printStackTrace ();
		}
		textFieldDesc.setFont (font);
		panelTextFieldDesc.add (textFieldDesc);

		JPanel panelDesc = new JPanel (new BorderLayout ());
		panelDesc.add (panelLabelDesc, BorderLayout.NORTH);
		panelDesc.add (panelTextFieldDesc, BorderLayout.SOUTH);

		// Partie pointCost
		JPanel panelLabelpointCost = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelpointCost = new JLabel ("PointCost :");
		panelLabelpointCost.add (labelpointCost);

		JPanel panelTextFieldpointCost= new JPanel (new FlowLayout (FlowLayout.RIGHT));
		spinnerPointCost = new JSpinner ();
		spinnerPointCost.setModel (pointCost);
		spinnerPointCost.addKeyListener (this);
		panelTextFieldpointCost.add (spinnerPointCost);

		JPanel panelPointCost = new JPanel (new BorderLayout ());
		panelPointCost.add (panelLabelpointCost, BorderLayout.WEST);
		panelPointCost.add (panelTextFieldpointCost, BorderLayout.EAST);

		// Partie defBonus
		JPanel panelLabeldefBonus = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labeldefBonus = new JLabel ("DefBonus :");
		panelLabeldefBonus.add (labeldefBonus);

		JPanel panelTextFielddefBonus = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		spinnerdefBonus = new JSpinner ();
		spinnerdefBonus.setModel (defBonus);
		spinnerdefBonus.addKeyListener (this);
		panelTextFielddefBonus.add (spinnerdefBonus);

		JPanel paneldefBonus = new JPanel (new BorderLayout ());
		paneldefBonus.add (panelLabeldefBonus, BorderLayout.WEST);
		paneldefBonus.add (panelTextFielddefBonus, BorderLayout.EAST);

		// Partie attBonus
		JPanel panelLabelattBonus = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelattBonus = new JLabel ("AttBonus :");
		panelLabelattBonus.add (labelattBonus);

		JPanel panelTextFieldattBonus = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		spinnerattBonus = new JSpinner ();
		spinnerattBonus.setModel (attBonus);
		spinnerattBonus.addKeyListener (this);
		panelTextFieldattBonus.add (spinnerattBonus);

		JPanel panelattBonus = new JPanel (new BorderLayout ());
		panelattBonus.add (panelLabelattBonus, BorderLayout.WEST);
		panelattBonus.add (panelTextFieldattBonus, BorderLayout.EAST);

		// Partie hpBonus
		JPanel panelLabelhpBonus = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelhpBonus = new JLabel ("HpBonus :");
		panelLabelhpBonus.add (labelhpBonus);

		JPanel panelTextFieldhpBonus = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		spinnerhpBonus = new JSpinner ();
		spinnerhpBonus.setModel (hpBonus);
		spinnerhpBonus.addKeyListener (this);
		panelTextFieldhpBonus.add (spinnerhpBonus);

		JPanel panelhpBonus = new JPanel (new GridLayout (1, 2));
		panelhpBonus.add (panelLabelhpBonus);
		panelhpBonus.add (panelTextFieldhpBonus);
		
		// Partie auraBonus
		JPanel panelLabelauraBonus = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelauraBonus = new JLabel ("AuraBonus :");
		panelLabelauraBonus.add (labelauraBonus);

		JPanel panelTextFieldauraBonus = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		spinnerAuraBonus = new JSpinner ();
		spinnerAuraBonus.setModel (auraBonus);
		spinnerAuraBonus.addKeyListener (this);
		panelTextFieldauraBonus.add (spinnerAuraBonus);

		JPanel panelauraBonus = new JPanel (new GridLayout (1, 2));
		panelauraBonus.add (panelLabelauraBonus);
		panelauraBonus.add (panelTextFieldauraBonus);
		
		// Partie powerBonus
		JPanel panelLabelpowerBonus = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelpowerBonus = new JLabel ("PowerBonus :");
		panelLabelpowerBonus.add (labelpowerBonus);

		JPanel panelTextFieldpowerBonus = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		spinnerPowerBonus = new JSpinner ();
		spinnerPowerBonus.setModel (powerBonus);
		spinnerPowerBonus.addKeyListener (this);
		panelTextFieldpowerBonus.add (spinnerPowerBonus);

		JPanel panelpowerBonus = new JPanel (new GridLayout (1, 2));
		panelpowerBonus.add (panelLabelpowerBonus);
		panelpowerBonus.add (panelTextFieldpowerBonus);

		// Partie attMalus
		JPanel panelLabelattMalus = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelattMalus = new JLabel ("AttMalus :");
		panelLabelattMalus.add (labelattMalus);

		JPanel panelTextFieldattMalus = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		spinnerAttMalus = new JSpinner ();
		spinnerAttMalus.setModel (attMalus);
		spinnerAttMalus.addKeyListener (this);
		panelTextFieldattMalus.add (spinnerAttMalus);

		JPanel panelattMalus = new JPanel (new BorderLayout ());
		panelattMalus.add (panelLabelattMalus, BorderLayout.WEST);
		panelattMalus.add (panelTextFieldattMalus, BorderLayout.EAST);
		
		// Partie defMalus
		JPanel panelLabeldefMalus = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labeldefMalus = new JLabel ("DefMalus :");
		panelLabeldefMalus.add (labeldefMalus);

		JPanel panelTextFielddefMalus = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		spinnerDefMalus = new JSpinner ();
		spinnerDefMalus.setModel (defMalus);
		spinnerDefMalus.addKeyListener (this);
		panelTextFielddefMalus.add (spinnerDefMalus);

		JPanel paneldefMalus = new JPanel (new BorderLayout ());
		paneldefMalus.add (panelLabeldefMalus, BorderLayout.WEST);
		paneldefMalus.add (panelTextFielddefMalus, BorderLayout.EAST);
		
		// Partie damages
		JPanel panelLabeldamages = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labeldamages = new JLabel ("Damages :");
		panelLabeldamages.add (labeldamages);

		JPanel panelTextFielddamages = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		spinnerDamages = new JSpinner ();
		spinnerDamages.setModel (damages);
		spinnerDamages.addKeyListener (this);
		panelTextFielddamages.add (spinnerDamages);

		JPanel paneldamages = new JPanel (new BorderLayout ());
		paneldamages.add (panelLabeldamages, BorderLayout.WEST);
		paneldamages.add (panelTextFielddamages, BorderLayout.EAST);
		
		// Partie hitSuccess
		JPanel panelLabelhitSuccess = new JPanel (new FlowLayout (FlowLayout.LEFT));
		JLabel labelhitSuccess = new JLabel ("HitSuccess :");
		panelLabelhitSuccess.add (labelhitSuccess);

		JPanel panelTextFieldhitSuccess = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		spinnerHitSuccess = new JSpinner ();
		spinnerHitSuccess.setModel (hitSuccess);
		spinnerHitSuccess.addKeyListener (this);
		panelTextFieldhitSuccess.add (spinnerHitSuccess);

		JPanel panelhitSuccess = new JPanel (new BorderLayout ());
		panelhitSuccess.add (panelLabelhitSuccess, BorderLayout.WEST);
		panelhitSuccess.add (panelTextFieldhitSuccess, BorderLayout.EAST);
		
		// Partie Button
		JPanel panelButtonSave = new JPanel (new FlowLayout (FlowLayout.RIGHT));
		buttonSave = new JButton ("Save");
		buttonSave.addActionListener (this);
		panelButtonSave.add (buttonSave);

		// Partie regroupement
		container.add (panelKey);
		container.add (panelName);
		container.add (panelType);
		container.add (new JSeparator (JSeparator.HORIZONTAL));
		container.add (panelDesc);
		container.add (new JSeparator (JSeparator.HORIZONTAL));
		container.add (panelPointCost);
		container.add (paneldefBonus);
		container.add (panelattBonus);
		container.add (panelhpBonus);
		container.add (panelauraBonus);
		container.add (panelpowerBonus);
		container.add (panelattMalus);
		container.add (paneldefMalus);
		container.add (paneldamages);
		container.add (panelhitSuccess);
		container.add (panelButtonSave);
	}

	private void ajouterMenuBar () {
		// Initialisation de la barre de menu
		menu = new JMenuBar ();

		// Initialisation des différents menu
		menuFile = new JMenu ("File");

		// Mnémonics
		menuFile.setMnemonic (KeyEvent.VK_F);

		// Les items des menus
		menuFileNew = new JMenuItem ("New");
		menuFileOpen = new JMenuItem ("Open");
		menuFileSave = new JMenuItem ("Save");
		menuFileQuit = new JMenuItem ("Quit");

		// Accélérateurs
		menuFileNew.setAccelerator (KeyStroke.getKeyStroke (KeyEvent.VK_N, KeyEvent.CTRL_DOWN_MASK));
		menuFileOpen.setAccelerator (KeyStroke.getKeyStroke (KeyEvent.VK_O, KeyEvent.CTRL_DOWN_MASK));
		menuFileSave.setAccelerator (KeyStroke.getKeyStroke (KeyEvent.VK_S, KeyEvent.CTRL_DOWN_MASK));
		menuFileQuit.setAccelerator (KeyStroke.getKeyStroke (KeyEvent.VK_Q, KeyEvent.CTRL_DOWN_MASK));

		// Listeners
		menuFileNew.addActionListener (this);
		menuFileOpen.addActionListener (this);
		menuFileSave.addActionListener (this);
		menuFileQuit.addActionListener (this);

		// On fixe la barre de menu et on lui ajoute tous les menus et items
		this.setJMenuBar (menu);
		menu.add (menuFile);
		menuFile.add (menuFileNew);
		menuFile.add (menuFileOpen);
		menuFile.add (menuFileSave);
		menuFile.add (menuFileQuit);
	}

	private void setNimbusLook () {
		// Look Nimbus, futur LAF multi-platforme par défaut (JDK 7) et
		// franchement il est largement mieux que l'actuel (Metal)
		for (UIManager.LookAndFeelInfo laf : UIManager.getInstalledLookAndFeels ()) {
			if ("Nimbus".equals (laf.getName ())) {
				try {
					UIManager.setLookAndFeel (laf.getClassName ());
					SwingUtilities.updateComponentTreeUI (this);
				}
				catch (Exception e) {}
			}
		}
	}

	/**
	 * 
	 */
	// m�thodes
	public void nouveau () {
		this.skill = new Skill ("", null, "", 0, 0, 0, 0, 0, 0, 0, 0, 0, "", 0, "");

		this.textFieldKey.setText ("");
		this.textFieldName.setText ("");
		this.textFieldType.setText ("");
		this.textFieldDesc.setText ("");
		this.spinnerPointCost.setValue (0);
		this.spinnerdefBonus.setValue (0);
		this.spinnerattBonus.setValue (0);
		this.spinnerhpBonus.setValue (0);
		this.spinnerAuraBonus.setValue (0);
		this.spinnerPowerBonus.setValue (0);
		this.spinnerAttMalus.setValue (0);
		this.spinnerDefMalus.setValue (0);
		this.spinnerDamages.setValue (0);
		this.spinnerHitSuccess.setValue (0);
	}

	public void fileChooser () {
		JFileChooser openFile = new JFileChooser (".");
		int returnValeur = openFile.showOpenDialog (this);
		if (returnValeur == JFileChooser.APPROVE_OPTION) this.ouvrir (openFile.getSelectedFile ().getAbsolutePath ());
	}

	public void ouvrir (String urlFile) {
		this.skill = (Skill) this.skillReader.getGameObject (urlFile);
		remplirChamps ();
		String[] strTmp = urlFile.split ("/");
		file = " - " + strTmp[strTmp.length - 1];
		editFile = "";
		this.setTitle (title + file + editFile);
	}

	public void appliquer () {
		this.skill.setKey (this.textFieldKey.getText ());
		this.skill.setName (this.textFieldName.getText ());
		this.skill.setSkillType (this.textFieldType.getText ());
		this.skill.setDescription (this.textFieldDesc.getText ());
		this.skill.setPointCost (this.pointCost.getNumber ().intValue ());
		this.skill.setDefBonus (this.defBonus.getNumber ().intValue ());
		this.skill.setAttBonus (this.attBonus.getNumber ().intValue ());
		this.skill.setHpBonus (this.hpBonus.getNumber ().intValue ());
		this.skill.setAuraBonus (this.auraBonus.getNumber ().intValue ());
		this.skill.setPowerBonus (this.powerBonus.getNumber ().intValue ());
		this.skill.setAttMalus (this.attMalus.getNumber ().intValue ());
		this.skill.setDefMalus (this.defMalus.getNumber ().intValue ());
		this.skill.setDamages (this.damages.getNumber ().intValue ());
		this.skill.setHitSuccess (this.hitSuccess.getNumber ().intValue ());
	}

	public void sauvegarder () {
		file = " - " + this.skillWriter.writeGM (this.skill);
		editFile = "";
		this.setTitle (title + file + editFile);
	}

	public void remplirChamps () {
		this.textFieldKey.setText (this.skill.getKey ());
		this.textFieldName.setText (this.skill.getName ());
		this.textFieldType.setText (this.skill.getSkillType ());
		this.textFieldDesc.setText (this.skill.getDescription ());
		this.spinnerPointCost.setValue (this.skill.getPointCost ());
		this.spinnerdefBonus.setValue (this.skill.getDefBonus ());
		this.spinnerattBonus.setValue (this.skill.getAttBonus ());
		this.spinnerhpBonus.setValue (this.skill.getHpBonus ());
		this.spinnerAuraBonus.setValue (this.skill.getAuraBonus ());
		this.spinnerPowerBonus.setValue (this.skill.getPowerBonus ());
		this.spinnerAttMalus.setValue (this.skill.getAttMalus ());
		this.spinnerDefMalus.setValue (this.skill.getDefMalus ());
		this.spinnerDamages.setValue (this.skill.getDamages ());
		this.spinnerHitSuccess.setValue (this.skill.getHitSuccess ());
	}

	public void save () {
		this.appliquer ();
		this.sauvegarder ();
		JOptionPane.showMessageDialog (null, "Le fichier a bien �t� sauvegard�.", "Confirmation", JOptionPane.INFORMATION_MESSAGE);
	}

	public void newF () {
		this.nouveau ();
		file = " - New File";
		editFile = "";
		this.setTitle (title + file + editFile);
	}

	public void actionPerformed (ActionEvent arg0) {
		if (arg0.getSource ().equals (this.menuFileNew)) {
			this.newF ();
		}
		else if (arg0.getSource ().equals (this.menuFileOpen)) {
			this.fileChooser ();
		}
		else if (arg0.getSource ().equals (this.menuFileSave)) {
			this.save ();
		}
		else if (arg0.getSource () == this.buttonSave) {
			this.save ();
		}
		else if (arg0.getSource ().equals (this.menuFileQuit)) {
			this.dispose ();
		}
	}

	/**
	 * @param args
	 */
	public static void main (String[] args) {
		new SkillMaker ();
	}

	@Override
	public void keyPressed (KeyEvent arg0) {
		if (this.isNewFile ()) file = " - New File";
		editFile = " *";
		this.setTitle (title + file + editFile);
	}

	@Override
	public void keyReleased (KeyEvent arg0) {}

	@Override
	public void keyTyped (KeyEvent arg0) {}

	// //////////////
	// Accesseurs //
	// //////////////
	/**
	 * @return the newFile
	 */
	public boolean isNewFile () {
		return newFile;
	}

	/**
	 * @param newFile
	 *            the newFile to set
	 */
	public void setNewFile (boolean newFile) {
		this.newFile = newFile;
	}

	/**
	 * @param edit
	 *            the edit to set
	 */
	public void setEdit (boolean edit) {
		this.edit = edit;
	}

	/**
	 * @return the edit
	 */
	public boolean isEdit () {
		return edit;
	}
}
