// ////////////////////////////////////////////////////////////////////////
// Copyright � 2011 J�r�my Chevrier, Hugo Buffet, J�r�my Lebrun
//
// This file is part of JZunBeHa.
//
// JZunBeHa is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// JZunBeHa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details. //
// You should have received a copy of the GNU General Public License
// along with JZunBeHa. If not, see <http://www.gnu.org/licenses/>.
// ////////////////////////////////////////////////////////////////////////

/**
 * 
 */

package tools.writers;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

import model.GameObject;
import model.Skill;

/**
 * Cette classe permet de mettre un skill sous la forme de .xdat.
 * 
 * @author Zunlame
 * @version 0.1.0 : 2011-02-02,10:33pm</br>
 * @version 0.1.1 : 2011-02-02,11:26pm</br>
 * 
 */
public class SkillWriter implements Writer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see modulesWriter.Writer#prepareLines(model.GameObject)
	 */
	@Override
	public ArrayList<String> prepareLines (GameObject gameObj) {

		ArrayList<String> lines = new ArrayList<String> ();

		Skill skill = (Skill) gameObj;

		lines.add ("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
		lines.add ("<Skill key='" + skill.getKey () + "' skillType='" + skill.getSkillType () + "' >");
		lines.add ("\t<name>" + skill.getName () + "</name>");
		lines.add ("\t<description>" + skill.getDescription () + "</description>");
		lines.add ("\t<pointCost>" +skill.getPointCost ()+"</pointCost>");
		lines.add ("\t<defBonus>" +skill.getDefBonus ()+"</defBonus>");
		lines.add ("\t<attBonus>" +skill.getAttBonus ()+"</attBonus>");
		lines.add ("\t<hpBonus>" +skill.getHpBonus ()+"</hpBonus>");
		lines.add ("\t<auraBonus>" +skill.getAuraBonus ()+"</auraBonus>");
		lines.add ("\t<powerBonus>" +skill.getPowerBonus ()+"</powerBonus>");
		lines.add ("\t<attMalus>" +skill.getAttMalus ()+"</attMalus>");
		lines.add ("\t<defMalus>" +skill.getDefMalus ()+"</defMalus>");
		lines.add ("\t<damages>" +skill.getDamages ()+"</damages>");
		lines.add ("\t<hitSuccess>" +skill.getHitSuccess ()+"</hitSuccess>");
		lines.add ("</Skill>");

		return lines;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see modulesWriter.Writer#writeGM(model.GameObject)
	 */
	@Override
	public String writeGM (GameObject gameObj) {

		ArrayList<String> lines = prepareLines (gameObj);

		FileWriter fw;
		BufferedWriter bw;
		PrintWriter pw = null;
		String fileName = gameObj.getName () + "_" + gameObj.getKey () + ".xdat";
		String nameFile = "data/ressources/battle/skills/properties/" + fileName;
		
		try {
			fw = new FileWriter (new File (nameFile));
			bw = new BufferedWriter (fw);
			pw = new PrintWriter (bw);
		}
		catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace ();
		}

		for (String line : lines) {
			pw.println (line);
		}

		pw.close ();
		return fileName;
	}

}
